<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
        <a-button v-show="showBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
        <j-upload-button v-show="showBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-dropdown v-if="selectedRowKeys.length > 0 && showBtn">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined" />
                删除
              </a-menu-item>
            </a-menu>
          </template>
          <a-button
            >批量操作
            <Icon icon="mdi:chevron-down" />
          </a-button>
        </a-dropdown>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'stRiskScenario.scenarioNo'">
          {{ record.stRiskScenario.scenarioNo }}
        </template>
        <template v-if="column.key === 'stRiskScenario.scenarioName'">
          <JEllipsisFormat :value="record.stRiskScenario.scenarioName" :length="60" />
        </template>
        <template v-if="column.key === 'stRiskScenario.applicableName'">
          {{ record.stRiskScenario.applicableName }}
        </template>
        <template v-if="column.key === 'stRiskScenario.lableNameList'">
          <JTagsFormat :value="record.stRiskEvent.lableNameList" :length="2" />
        </template>
        <template v-if="column.key === 'stRiskEvent.riskEventName'">
          <JEllipsisFormat :value="record.stRiskEvent.riskEventName" :length="60" />
        </template>
        <template v-else-if="column.key === 'stRiskEvent.riskEventDesc'">
          <JEllipsisFormat :value="record.stRiskEvent.riskEventDesc" :length="60" />
        </template>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{ text }">
        <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{ text }">
        {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{ text }">
        <span v-if="!text" style="font-size: 12px; font-style: italic">无文件</span>
        <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <StRiskEventModal @register="registerModal" @success="handleSuccess" />
  </div>
</template>

<script lang="ts" name="risk.event-stRiskEvent" setup>
  import { reactive, ref, toRaw, unref } from 'vue';
  import JEllipsisFormat from '../components/JEllipsisFormat.vue';
  import JTagsFormat from '../components/JTagsFormat.vue';
  import { batchDelete, deleteOne, getExportUrl, getImportUrl, list } from './StRiskEvent.api';
  import { columns, searchFormSchema } from './StRiskEvent.data';
  import StRiskEventModal from './components/StRiskEventModal.vue';
  import { useModal } from '/@/components/Modal';
  import { BasicTable, TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { downloadFile } from '/@/utils/common/renderUtils';
  const showBtn = ref(false);
  const props = defineProps({
    complianeInfoRecord: {},
  });
  const emit = defineEmits(['success']);
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, { openModal }] = useModal();
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '风险事件',
      api: list,
      columns,
      canResize: false,
      showTableSetting: false,
      useSearchForm: false,
      immediate: false,
      formConfig: {
        //labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: true,
        fieldMapToNumber: [],
        fieldMapToTime: [],
      },
      actionColumn: {
        width: 120,
        fixed: 'right',
      },
    },
    exportConfig: {
      name: '风险事件',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
      success: handleSuccess,
    },
  });

  const [registerTable, { reload, setProps }, { rowSelection, selectedRowKeys }] = tableContext;
  //-----自定义查询----begin--------
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 8 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });
  const queryParam = reactive({});
  function initParam() {
    const schemas = unref(searchFormSchema);
    schemas.forEach((item) => {
      queryParam[item.field] = '';
    });
  }
  initParam();
  function searchQuery() {
    setProps({ searchInfo: toRaw(queryParam) });
    reload();
  }
  function searchReset() {
    //Object.assign(queryParam,{ name: '',age_begin: '',age_end: '',sex: '',id: ''});
    initParam();
    reload();
  }
  // watch(
  //     ()=>props.complianeInfoRecord,
  //     (newVal,oldVla)=>{
  //       console.log("----")
  //       console.log(newVal)
  //       let parm = {complianeNo:newVal.complianeNo}
  //       setProps({searchInfo:parm});
  //       reload()
  //       console.log(oldVla)
  //       console.log("---")
  //     }
  // )
  //自定义查询----end---------
  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      complianeNo: props.complianeInfoRecord.complianeNo,
      isUpdate: false,
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    let stRiskEvent = record.stRiskEvent;
    console.log(stRiskEvent);
    openModal(true, {
      record: stRiskEvent,
      isUpdate: true,
      showFooter: false,
    });
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }

  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
    emit('success');
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '删除',
        color: 'error',
        popConfirm: {
          title: '你确定要删除选中的条目吗？',
          confirm: handleDelete.bind(null, record),
        },
      },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      //  {
      //    label: '详情',
      //    onClick: handleDetail.bind(null, record),
      //  },
    ];
  }
  defineExpose({ setProps, reload });
</script>

<style scoped></style>
